diff --git a/libavcodec/v210enc.c b/libavcodec/v210enc.c
index 2400538f73..1b17d885cc 100644
--- a/libavcodec/v210enc.c
+++ b/libavcodec/v210enc.c
@@ -89,15 +89,77 @@ FF_ENABLE_DEPRECATION_WARNINGS
     return 0;
 }
 
+#define DEFINE_V210_ENCODE_FUNC(nbits, depth)                                 \
+static void v210_enc_##depth(AVCodecContext *avctx,                           \
+        uint8_t *dst, const AVFrame *pic)                                     \
+{                                                                             \
+    V210EncContext *s = avctx->priv_data;                                     \
+    int aligned_width = ((avctx->width + 47) / 48) * 48;                      \
+    int stride = aligned_width * 8 / 3;                                       \
+    int line_padding = stride - ((avctx->width * 8 + 11) / 12) * 4;           \
+    int h, w;                                                                 \
+    int bytes = nbits / 8;                                                    \
+    const uint##nbits##_t *y = (const uint##nbits##_t *)pic->data[0];         \
+    const uint##nbits##_t *u = (const uint##nbits##_t *)pic->data[1];         \
+    const uint##nbits##_t *v = (const uint##nbits##_t *)pic->data[2];         \
+    const int sample_size = 6 * s->sample_factor_##depth;                     \
+    const int sample_w    = avctx->width / sample_size;                       \
+                                                                              \
+    for (h = 0; h < avctx->height; h++) {                                     \
+        uint32_t val;                                                         \
+        w = sample_w * sample_size;                                           \
+        s->pack_line_##depth (y, u, v, dst, w);                               \
+                                                                              \
+        y += w;                                                               \
+        u += w >> 1;                                                          \
+        v += w >> 1;                                                          \
+        dst += sample_w * 16 * s->sample_factor_##depth;                      \
+                                                                              \
+        for (; w < avctx->width - 5; w += 6) {                                \
+            WRITE_PIXELS(u, y, v, depth);                                     \
+            WRITE_PIXELS(y, u, y, depth);                                     \
+            WRITE_PIXELS(v, y, u, depth);                                     \
+            WRITE_PIXELS(y, v, y, depth);                                     \
+        }                                                                     \
+        if (w < avctx->width - 1) {                                           \
+            WRITE_PIXELS(u, y, v, depth);                                     \
+                                                                              \
+            val = CLIP(*y++, depth) << (10-depth);                            \
+            if (w == avctx->width - 2) {                                      \
+                AV_WL32(dst, val);                                            \
+                dst += 4;                                                     \
+            }                                                                 \
+        }                                                                     \
+        if (w < avctx->width - 3) {                                           \
+            val |= (CLIP(*u++, depth) << (20-depth)) |                        \
+                    (CLIP(*y++, depth) << (30-depth));                        \
+            AV_WL32(dst, val);                                                \
+            dst += 4;                                                         \
+                                                                              \
+            val = CLIP(*v++, depth) << (10-depth) |                           \
+                    (CLIP(*y++, depth) << (20-depth));                        \
+            AV_WL32(dst, val);                                                \
+            dst += 4;                                                         \
+        }                                                                     \
+                                                                              \
+        memset(dst, 0, line_padding);                                         \
+        dst += line_padding;                                                  \
+        y += pic->linesize[0] / bytes - avctx->width;                         \
+        u += pic->linesize[1] / bytes - avctx->width / 2;                     \
+        v += pic->linesize[2] / bytes - avctx->width / 2;                     \
+    }                                                                         \
+}
+
+DEFINE_V210_ENCODE_FUNC(8, 8)
+DEFINE_V210_ENCODE_FUNC(16, 10);
+
 static int encode_frame(AVCodecContext *avctx, AVPacket *pkt,
                         const AVFrame *pic, int *got_packet)
 {
-    V210EncContext *s = avctx->priv_data;
     int aligned_width = ((avctx->width + 47) / 48) * 48;
     int stride = aligned_width * 8 / 3;
-    int line_padding = stride - ((avctx->width * 8 + 11) / 12) * 4;
     AVFrameSideData *side_data;
-    int h, w, ret;
+    int ret;
     uint8_t *dst;
 
     ret = ff_alloc_packet2(avctx, pkt, avctx->height * stride, avctx->height * stride);
@@ -107,105 +169,10 @@ static int encode_frame(AVCodecContext *avctx, AVPacket *pkt,
     }
     dst = pkt->data;
 
-    if (pic->format == AV_PIX_FMT_YUV422P10) {
-        const uint16_t *y = (const uint16_t *)pic->data[0];
-        const uint16_t *u = (const uint16_t *)pic->data[1];
-        const uint16_t *v = (const uint16_t *)pic->data[2];
-
-        const int sample_size = 6 * s->sample_factor_10;
-        const int sample_w    = avctx->width / sample_size;
-
-        for (h = 0; h < avctx->height; h++) {
-            uint32_t val;
-            w = sample_w * sample_size;
-            s->pack_line_10(y, u, v, dst, w);
-
-            y += w;
-            u += w >> 1;
-            v += w >> 1;
-            dst += sample_w * 16 * s->sample_factor_10;
-
-            for (; w < avctx->width - 5; w += 6) {
-                WRITE_PIXELS(u, y, v, 10);
-                WRITE_PIXELS(y, u, y, 10);
-                WRITE_PIXELS(v, y, u, 10);
-                WRITE_PIXELS(y, v, y, 10);
-            }
-            if (w < avctx->width - 1) {
-                WRITE_PIXELS(u, y, v, 10);
-
-                val = CLIP(*y++, 10);
-                if (w == avctx->width - 2) {
-                    AV_WL32(dst, val);
-                    dst += 4;
-                }
-            }
-            if (w < avctx->width - 3) {
-                val |= (CLIP(*u++, 10) << (20-10)) | (CLIP(*y++, 10) << (30-10));
-                AV_WL32(dst, val);
-                dst += 4;
-
-                val = CLIP(*v++, 10) << (10-10) | (CLIP(*y++, 10) << (20-10));
-                AV_WL32(dst, val);
-                dst += 4;
-            }
-
-            memset(dst, 0, line_padding);
-            dst += line_padding;
-            y += pic->linesize[0] / 2 - avctx->width;
-            u += pic->linesize[1] / 2 - avctx->width / 2;
-            v += pic->linesize[2] / 2 - avctx->width / 2;
-        }
-    } else if(pic->format == AV_PIX_FMT_YUV422P) {
-        const uint8_t *y = pic->data[0];
-        const uint8_t *u = pic->data[1];
-        const uint8_t *v = pic->data[2];
-
-        const int sample_size = 6 * s->sample_factor_8;
-        const int sample_w    = avctx->width / sample_size;
-
-        for (h = 0; h < avctx->height; h++) {
-            uint32_t val;
-            w = sample_w * sample_size;
-            s->pack_line_8(y, u, v, dst, w);
-
-            y += w;
-            u += w >> 1;
-            v += w >> 1;
-            dst += sample_w * 16 * s->sample_factor_8;
-
-            for (; w < avctx->width - 5; w += 6) {
-                WRITE_PIXELS(u, y, v, 8);
-                WRITE_PIXELS(y, u, y, 8);
-                WRITE_PIXELS(v, y, u, 8);
-                WRITE_PIXELS(y, v, y, 8);
-            }
-            if (w < avctx->width - 1) {
-                WRITE_PIXELS(u, y, v, 8);
-
-                val = CLIP(*y++, 8) << (10-8);
-                if (w == avctx->width - 2) {
-                    AV_WL32(dst, val);
-                    dst += 4;
-                }
-            }
-            if (w < avctx->width - 3) {
-                val |= (CLIP(*u++, 8) << (20-8)) | (CLIP(*y++, 8) << (30-8));
-                AV_WL32(dst, val);
-                dst += 4;
-
-                val = (CLIP(*v++, 8) << (10-8)) | (CLIP(*y++, 8) << (20-8));
-                AV_WL32(dst, val);
-                dst += 4;
-            }
-            memset(dst, 0, line_padding);
-            dst += line_padding;
-
-            y += pic->linesize[0] - avctx->width;
-            u += pic->linesize[1] - avctx->width / 2;
-            v += pic->linesize[2] - avctx->width / 2;
-        }
-    }
+    if (pic->format == AV_PIX_FMT_YUV422P10)
+        v210_enc_10(avctx, dst, pic);
+    else if(pic->format == AV_PIX_FMT_YUV422P)
+        v210_enc_8(avctx, dst, pic);
 
     side_data = av_frame_get_side_data(pic, AV_FRAME_DATA_A53_CC);
     if (side_data && side_data->size) {